#include <GL/glut.h>
#include "NewCamera.h"


Camera::Camera(void) {
	CamPosition.x=0;
	CamPosition.y=0;
	CamPosition.z=0;
	Direction.x=0;
	Direction.y=0;
	Direction.z=0;
}

Camera::Camera(double x,double y,double z) {
	CamPosition.x=x;
	CamPosition.y=y;
	CamPosition.z=z;
	Direction.x=0;
	Direction.y=0;
	Direction.z=1;
	UpVector.x=0;
	UpVector.y=1;
	UpVector.z=0;
	Side.x=1;
	Side.y=0;
	Side.z=0;
}

void Camera::DefineVal(Vector Pos,Vector Dir) {
	CamPosition=Pos;
	Dir.Normalize();
	Direction=Dir;
}

Camera::~Camera(void) {

}

void Camera::TranslateCam(float In_Out,float Left_Right) {
//	CamPosition=CamPosition+((Direction*In_Out)+(Side*Left_Right));
	CamPosition.x=CamPosition.x+((Direction.x*In_Out)+(Side.x*Left_Right));
	CamPosition.y=CamPosition.y+((Direction.y*In_Out)+(Side.y*Left_Right));
	CamPosition.z=CamPosition.z-((Direction.z*In_Out)+(Side.z*Left_Right));
	
}

void Camera::RotateCam(double Teta,double Psi) {
	Side.x=cos(Teta);
	Side.y=Side.y;
	Side.z=sin(Teta);
	Side.Normalize();

	
	UpVector.x=0;
	UpVector.y=1;
	UpVector.z=0;
	Vector V1,V2;
	V1.x=sin(Teta);
	V1.y=0;
	V1.z=cos(Teta);
	V2.x=0;
	V2.y=sin(Psi);
	V2.z=cos(Psi);
	Direction=V1+V2;
	Direction.Normalize();

}



Vector Camera::ShakeIt(double Teta,double Psi) {
	Vector V1,V2,Result;
	V1.x=sin(Teta);
	V1.y=0;
	V1.z=cos(Teta);
	V2.x=0;
	V2.y=sin(Psi);
	V2.z=cos(Psi);
	UpVector.x=sin(Teta)*cos(Psi);
	UpVector.y=cos(Psi);
	UpVector.z=-sin(Psi);
	Result=V1+V2;
	return Result;
}


void Camera::CameraView(void) {
//	Direction=ShakeIt(Teta,Psi);
//	Direction.Normalize();

//	CamPosition.x=CamPosition.x+(Fwd_Bck*Direction.x);
//	CamPosition.y=CamPosition.y+(Fwd_Bck*Direction.y);
//	CamPosition.z=CamPosition.z+(Fwd_Bck*Direction.z);
//	RotateCam(Teta,Psi);

	gluLookAt(CamPosition.x,CamPosition.y,CamPosition.z,
		      CamPosition.x+Direction.x,CamPosition.y+Direction.y,CamPosition.z-Direction.z,
			  UpVector.x,UpVector.y,UpVector.z);
}







