#include <windows.h>
#include <stdio.h>
#include <iostream.h>
#include <GL/glaux.h>
#include <GL/glut.h>
#include <mmsystem.h> 
#include "Terrain.h"
#include "mathclass.h"
#include "NewCamera.h"
#include "ParticleManager.h"
/********************************************************************/
void InitScene(void);
void DrawScene(void);
void Idle(void);
GLvoid glPrint(const char *fmt, ...);
void Blank();
/********************************************************************/
#define HeightMult 2.5f 

float Fwd_Bck=0.0f; 
double PreviousX=0,PreviousY=0;
float delta;
int width=800;
int height=600;
float Alpha=0.0f;
float anim=true;
Vector CamPos,CamDir;

GLuint PreTerrain; 
GLfloat LightAmbient[]={0.1f,0.1f,0.1f,1.0f}; 
GLfloat LightDiffuse[]={0.2f,0.2f,0.2f,1.0f}; 
GLfloat LightPosition[]={0.2f,1.0f,-0.6f}; 
GLfloat FogColor[]={0.5f,0.5f,0.5f,.5f};

Terrain Terreno("Terrain.raw",2048,16); 
Camera Peep(0,0.5,1);

CParticleManager ParticleManager(&Terreno);
Vector rainpos(0.0f,4.0f,0.0f);
Vector lightningpos(0.0f,4.0f,0.0f);
Vector smokepos(0.32f,0.32f,-0.5f);

CParticleRain Rain(rainpos);
CParticleLightning Lightning(lightningpos);
CParticleSmoke Smoke(smokepos,0);
CParticleSmoke Fire(smokepos,1); // TEM QUE CARREGAR
SmokeParams FireParams;

DWORD PreviousTime, CurrentTime;



/********************************************************************/
void main(int argcp,char ** argv) {
	glutInit(&argcp,argv);
	glutInitWindowSize(width,height);
	glutInitWindowPosition(0,0);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
	glutCreateWindow("Terrain Preview");

	InitScene();

	glutDisplayFunc(DrawScene);
	glutIdleFunc(Idle);
	
	glutMainLoop();
}

int counter=0;
float framecounter=0;

float events[]= { 0,8000, 15000,20000, 31000, 33000 };

void Blank() {
   glColor4f(1.0f,1.0f,1.0f,Alpha);
   glEnable(GL_BLEND);
   
   glBegin(GL_QUADS); // desenha um quad do tamanho na tela, branco com blend
   glVertex2i(0,0);
   glVertex2i(width,0);
   glVertex2i(width,height);
   glVertex2i(0,height);
   glEnd();
   bool blankmode=true;
   glDisable(GL_BLEND);
   if (blankmode) {
      if (Alpha<1.0) {
         Alpha+=0.01;
      } else {
         blankmode=false;
      }
   } else {
      if (Alpha>0.0f) {
         Alpha-=0.01;
      }
   }
   
}


void Idle(void) {
	CurrentTime=timeGetTime();
	delta=CurrentTime-PreviousTime;
	framecounter+=delta;

	if (events[counter]<=framecounter) {
		switch (counter) {
		case 0: // Smoke;
			Smoke.Start();
			counter++;
			break;
		case 1:
			CamPos.x=0.5f;
			CamPos.y=0.3f;
			CamPos.z=0.7f;
			CamDir.x=0.0f;
			CamDir.y=0.0f;
			CamDir.z=1.0f;
			Peep.DefineVal(CamPos,CamDir);
			counter++;
			break;
		
		case 2:
			Smoke.Stop();
			Fire.Start();
			counter++;
			break;
		case 3: 
			CamPos.x=-0.7f;
			CamPos.y=0.25f;
			CamPos.z=0.8f;
			CamDir.x=0.6f;
			CamDir.y=0.0f;
			CamDir.z=1.0f;
			Peep.DefineVal(CamPos,CamDir);
			counter++;
			break;
		
		case 4:
			Fire.Stop();
			counter++;
			break;
		case 5:
			glMatrixMode(GL_PROJECTION);
			glPushMatrix();
			glLoadIdentity();
    
			glOrtho(0.0f,width,height,0.0f,-1.0f,1.0f);
    
			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
			glLoadIdentity();   
			Blank();
			counter++;
			anim=false;
						PlaySound("happy.wav", NULL, SND_ASYNC | SND_LOOP);
			glRasterPos2f(0.0f, 0.0f);
			glTranslatef(0.0f,0.0f,-1.0f);
			glPrint("Boga");
			break;
		case 6: 

			
			break;

			//glMatrixMode(GL_PROJECTION);
			//glPopMatrix();
			//glMatrixMode(GL_MODELVIEW);
			//glLoadIdentity();

		}

	}
		

	DrawScene();
}

void InitScene(void) {
	glClearColor(0.0f,0.0f,0.0f,0.0f);
	glShadeModel(GL_SMOOTH);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
    glViewport(0,0,width,height);
	//glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_SRC_COLOR);

	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0f,((float) width/(float) height),0.1f,550.0f);
    
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	
	glEnable(GL_TEXTURE_2D);
	Terreno.LoadGLTextures();
	
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT1,GL_AMBIENT,LightAmbient);
	glLightfv(GL_LIGHT1,GL_DIFFUSE,LightDiffuse);
	glLightfv(GL_LIGHT1,GL_POSITION,LightPosition);
	glEnable(GL_LIGHT1);

	glFogi(GL_FOG_MODE,GL_EXP);
	glFogfv(GL_FOG_COLOR,FogColor);
	glFogf(GL_FOG_DENSITY,0.4f);
	glHint(GL_FOG_HINT,GL_NICEST);
	glFogf(GL_FOG_START,-4.5f);
	glFogf(GL_FOG_END,4.5f);
	glEnable(GL_FOG);

	Terreno.Initialize();
	Terreno.BuildMe();

	FireParams.MaxLife=10;
	FireParams.MaxParticles=300;
	FireParams.Speed=0.0005;
	FireParams.Spread=0.0003f;
	FireParams.Step=0.1f;
	FireParams.Gravity=0.00005f;
	FireParams.AtTime=10;
	FireParams.MaxHeight=2.0f;
	FireParams.size=0.03f;


	Fire.SetDefaults(FireParams);
	Rain.SmoothStart();
	//Smoke.Start();
	//Fire.Start();

	ParticleManager.AddSystem(&Rain);
	ParticleManager.AddSystem(&Lightning);
	ParticleManager.AddSystem(&Smoke);
	ParticleManager.AddSystem(&Fire);
	PlaySound("rain.wav", NULL, SND_ASYNC | SND_LOOP );
	//mciSendString("rain.wav", NULL, NULL, NULL);

	PreviousTime=timeGetTime();

}

void DrawScene(void) {
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	if (anim) {
		Peep.CameraView();

		glCallList(PreTerrain);

		ParticleManager.Update(delta);
		PreviousTime=CurrentTime;

		Terreno.CreateWaterPlane();
		//Terreno.BuildMe();
	}
	glutSwapBuffers();
}


/********************************************************************/
Terrain::Terrain(void) {
	Dimension=0;
	BigDimension=0;
	QuadSize=0;
	Ratio=0;
	HeightMatrix=NULL;
	acumulator=0.0f;
}  

Terrain::Terrain(char * FileName,int Size,int QSize) {
	SkyDome=gluNewQuadric();
	gluQuadricNormals(SkyDome, GLU_SMOOTH);
	gluQuadricOrientation(SkyDome,GLU_INSIDE);
	gluQuadricTexture(SkyDome, GL_TRUE);
	Sphere=gluNewQuadric();
	//gluQuadricNormals(Sphere, GLU_SMOOTH);
	//gluQuadricOrientation(Sphere,GLU_OUTSIDE);
	gluQuadricTexture(Sphere, GL_TRUE);

	Dimension=Size;
	QuadSize=QSize; 
	Ratio=Dimension/2; 
	BigDimension=Dimension*Dimension; 
	Quads=Dimension/QuadSize;
	NumTiles=Quads*Quads*4;
	
	HeightMatrix=new BYTE[BigDimension];
	
	DrawMatrix=new MapTile[NumTiles];

	VertexArray=new GLfloat[Quads*Quads*18];
	std::cout << "new [" << (Quads*Quads*18) << "]" << std::endl;
	NormalArray=new GLfloat[Quads*Quads*18];
	TexArray=new GLfloat[Quads*Quads*12];

	try {

	FILE * MatrixFile=NULL;
	MatrixFile=fopen(FileName,"rb");

	fread(HeightMatrix,1,BigDimension,MatrixFile);

	fclose(MatrixFile);
	}
	catch (...) {
		std::cout << "Failed to open heightmap." << std::endl;
		throw ("Could not open heightmap data.");
	}
}

Terrain::~Terrain(void) {
	Dimension=0;
	BigDimension=0;
	Ratio=0;
	QuadSize=0;
	delete[] HeightMatrix; 
	HeightMatrix=NULL;
	delete[] DrawMatrix;
	delete[] VertexArray;
	DrawMatrix=NULL;
	gluDeleteQuadric(SkyDome);
}

float Terrain::GetHeight(int x,int y) {
	int NewX,NewY;
	NewX=(x+Ratio)%Dimension;
	NewY=(y+Ratio)%Dimension;
	return HeightMatrix[NewX+(NewY*Dimension)];
}

void Terrain::CreateWaterPlane() {
	//Water Surface
	acumulator-=0.0005f*delta;
	glBindTexture(GL_TEXTURE_2D,texture[1]);
	//glEnable(GL_TEXTURE_GEN_S);
	//glEnable(GL_TEXTURE_GEN_T);
	glColor4f(1.0f,1.0f,1.0f,1.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	
	glBegin(GL_QUADS);
		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f+acumulator);glVertex3f(-1.0f,0.15f,-1.0f);
		glTexCoord2f(0.0f,10.0f+acumulator);glVertex3f(-1.0f,0.15f,1.0f);
		glTexCoord2f(10.0f,10.0f+acumulator);glVertex3f(0.0f,0.15f,1.0f);
		glTexCoord2f(10.0f,0.0f+acumulator);glVertex3f(0.0f,0.15f,-1.0f);

		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f,0.0f);glVertex3f(0.0f,0.15f,-1.0f);
		glTexCoord2f(0.0f,10.0f);glVertex3f(0.0f,0.15f,1.0f);
		glTexCoord2f(10.0f,10.0f);glVertex3f(1.0f,0.15f,1.0f);
		glTexCoord2f(10.0f,0.0f);glVertex3f(1.0f,0.15f,-1.0f);
	glEnd();

	glDisable(GL_BLEND);
	//glDisable(GL_TEXTURE_GEN_S);
	//glDisable(GL_TEXTURE_GEN_T);
}

void Terrain::DrawTree(int Quad) {
	glTexCoord2f(0.0f,0.0f);glVertex3f(DrawMatrix[Quad*2].Vertex1.x,DrawMatrix[Quad*2].Vertex1.y,DrawMatrix[Quad*2].Vertex1.z);
	glTexCoord2f(1.0f,0.0f);glVertex3f(DrawMatrix[Quad*2].Vertex3.x,DrawMatrix[Quad*2].Vertex3.y,DrawMatrix[Quad*2].Vertex3.z);
	glTexCoord2f(1.0f,1.0f);glVertex3f(DrawMatrix[Quad*2].Vertex3.x,DrawMatrix[Quad*2].Vertex3.y+0.05f,DrawMatrix[Quad*2].Vertex3.z);
	glTexCoord2f(0.0f,1.0f);glVertex3f(DrawMatrix[Quad*2].Vertex1.x,DrawMatrix[Quad*2].Vertex1.y+0.05f,DrawMatrix[Quad*2].Vertex1.z);
	
	glTexCoord2f(0.0f,0.0f);glVertex3f(DrawMatrix[(Quad*2)+1].Vertex2.x,DrawMatrix[(Quad*2)+1].Vertex2.y,DrawMatrix[(Quad*2)+1].Vertex2.z);
	glTexCoord2f(1.0f,0.0f);glVertex3f(DrawMatrix[Quad*2].Vertex2.x,DrawMatrix[Quad*2].Vertex2.y,DrawMatrix[Quad*2].Vertex2.z);
	glTexCoord2f(1.0f,1.0f);glVertex3f(DrawMatrix[Quad*2].Vertex2.x,DrawMatrix[Quad*2].Vertex2.y+0.05f,DrawMatrix[Quad*2].Vertex2.z);
	glTexCoord2f(0.0f,1.0f);glVertex3f(DrawMatrix[(Quad*2)+1].Vertex2.x,DrawMatrix[(Quad*2)+1].Vertex2.y+0.05f,DrawMatrix[(Quad*2)+1].Vertex2.z);
}

void Terrain::DrawTrees(void) {
	glBindTexture(GL_TEXTURE_2D,Tree[0].texID);
//	glEnable(GL_BLEND);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_EQUAL,1);
	glBegin(GL_QUADS);

	int i=0;
	while (i<NumTiles) 	{
		if ((DrawMatrix[i].Vertex1.y>0.15f) && (DrawMatrix[i].Vertex1.y<0.16f)) {
			DrawTree(i/2);
		}
		//i=i+30+((rand()/RAND_MAX)*30);
		i=i+30+(30)*rand()/RAND_MAX;
	}
	
	//DrawTree(5000);
	glEnd();
//	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
}

void Terrain::Initialize(void) {
	float X=-Ratio,Z=-Ratio;
	Vector Vertex1,Vertex2,Vertex3,Vertex4;
	Vector NormalComp1,NormalComp2,NormalComp3,NormalComp4,NormalComp5,NormalComp6,NormalComp7,NormalComp8,Normal;
	
	for (int Linhas=0;Linhas<Quads;Linhas++) {
		X+=QuadSize;
		Z=-Ratio;
		for (int Colunas=0;Colunas<Quads;Colunas++) {
			VertexArray[((Linhas*Quads*18)+(Colunas*18))]=X/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+1]=(GetHeight(X,Z)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+2]=Z/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+3]=(X+QuadSize)/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+4]=(GetHeight(X+QuadSize,Z)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+5]=Z/Ratio;			
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+6]=(X+QuadSize)/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+7]=(GetHeight(X+QuadSize,Z+QuadSize)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+8]=(Z+QuadSize)/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+9]=X/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+10]=(GetHeight(X,Z)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+11]=Z/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+12]=X/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+13]=(GetHeight(X,Z+QuadSize)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+14]=(Z+QuadSize)/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+15]=(X+QuadSize)/Ratio;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+16]=(GetHeight(X+QuadSize,Z+QuadSize)/Ratio)*HeightMult;
			VertexArray[((Linhas*Quads*18)+(Colunas*18))+17]=(Z+QuadSize)/Ratio;

			Vertex1.x=X/Ratio;
			Vertex1.y=(GetHeight(X,Z)/Ratio)*HeightMult;
			Vertex1.z=Z/Ratio;
			Vertex2.x=(X+QuadSize)/Ratio;
			Vertex2.y=(GetHeight(X+QuadSize,Z)/Ratio)*HeightMult;
			Vertex2.z=Z/Ratio;			
			Vertex3.x=(X+QuadSize)/Ratio;
			Vertex3.y=(GetHeight(X+QuadSize,Z+QuadSize)/Ratio)*HeightMult;
			Vertex3.z=(Z+QuadSize)/Ratio;
			Vertex4.x=X/Ratio;
			Vertex4.y=(GetHeight(X,Z+QuadSize)/Ratio)*HeightMult;
			Vertex4.z=(Z+QuadSize)/Ratio;
				
			DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].Vertex1=Vertex1;
			DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].Vertex2=Vertex2;
			DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].Vertex3=Vertex3;

			DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].Vertex1=Vertex1;
			DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].Vertex2=Vertex4;
			DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].Vertex3=Vertex3;
			
			NormalComp1=Vertex2;NormalComp2=Vertex1;	
			NormalComp3=NormalComp1-NormalComp2;
			NormalComp2=Vertex3;
			NormalComp4=NormalComp2-NormalComp1;
			Normal=NormalComp4%NormalComp3;
			Normal.Normalize();
			
			DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].FaceNormal=Normal;

			NormalComp1=Vertex4;NormalComp2=Vertex1;	
			NormalComp3=NormalComp2-NormalComp1;
			NormalComp2=Vertex3;
			NormalComp4=NormalComp2-NormalComp1;
			Normal=NormalComp4%NormalComp3;
			Normal.Normalize();
			Normal;

			DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].FaceNormal=Normal;

			if (((((Linhas-1)*Quads*2)+((Colunas-1)*2))<0) || ((((Linhas-1)*Quads*2)+((Colunas-1)*2))>NumTiles)) {
				NormalComp1.x=0;NormalComp1.y=0;NormalComp1.z=0;
				NormalComp2.x=0;NormalComp2.y=0;NormalComp2.z=0;
			} else {
				NormalComp1=DrawMatrix[((Linhas-1)*Quads*2)+((Colunas-1)*2)].FaceNormal;
				NormalComp2=DrawMatrix[(((Linhas-1)*Quads*2)+((Colunas-1)*2))+1].FaceNormal;
			}

			if (((((Linhas-1)*Quads*2)+(Colunas*2))<0) || ((((Linhas-1)*Quads*2)+(Colunas*2))>NumTiles)) {
		//		NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
				NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
			} else {
		//		NormalComp3=DrawMatrix[((Linhas-1)*Quads*2)+(Colunas*2)].FaceNormal;
				NormalComp3=DrawMatrix[(((Linhas-1)*Quads*2)+(Colunas*2))+1].FaceNormal;
			}

			if ((((Linhas*Quads*2)+(Colunas*2))<0) || (((Linhas*Quads*2)+(Colunas*2))>NumTiles)) {
				NormalComp4.x=0;NormalComp4.y=0;NormalComp4.z=0;
				NormalComp5.x=0;NormalComp5.y=0;NormalComp5.z=0;
			} else {
				NormalComp4=DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].FaceNormal;
				NormalComp5=DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].FaceNormal;
			}

			if ((((Linhas*Quads*2)+((Colunas-1)*2))<0) || (((Linhas*Quads*2)+((Colunas-1)*2))>NumTiles)) {
				NormalComp6.x=0;NormalComp6.y=0;NormalComp6.z=0;
		//		NormalComp8.x=0;NormalComp8.y=0;NormalComp8.z=0;
			} else {
				NormalComp6=DrawMatrix[(Linhas*Quads*2)+((Colunas-1)*2)].FaceNormal;
		//		NormalComp8=DrawMatrix[((Linhas*Quads*2)+((Colunas-1)*2))+1].FaceNormal;
			}

			Normal=NormalComp1+NormalComp2+NormalComp3+NormalComp4+NormalComp5+NormalComp6;
			Normal.Normalize();
			
			NormalArray[((Linhas*Quads*18)+(Colunas*18))]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+1]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+2]=Normal.z;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+9]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+10]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+11]=Normal.z;
			
			if (((((Linhas-1)*Quads*2)+((Colunas)*2))<0) || ((((Linhas-1)*Quads*2)+((Colunas)*2))>NumTiles)) {
				NormalComp1.x=0;NormalComp1.y=0;NormalComp1.z=0;
				NormalComp2.x=0;NormalComp2.y=0;NormalComp2.z=0;
			} else {
				NormalComp1=DrawMatrix[((Linhas-1)*Quads*2)+((Colunas)*2)].FaceNormal;
				NormalComp2=DrawMatrix[(((Linhas-1)*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			if (((((Linhas-1)*Quads*2)+((Colunas+1)*2))<0) || ((((Linhas-1)*Quads*2)+((Colunas+1)*2))>NumTiles)) {
		//		NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
				NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
			} else {
		//		NormalComp3=DrawMatrix[((Linhas-1)*Quads*2)+((Colunas+1)*2)].FaceNormal;
				NormalComp3=DrawMatrix[(((Linhas-1)*Quads*2)+((Colunas+1)*2))+1].FaceNormal;
			}

			if ((((Linhas*Quads*2)+((Colunas+1)*2))<0) || (((Linhas*Quads*2)+((Colunas+1)*2))>NumTiles)) {
				NormalComp4.x=0;NormalComp4.y=0;NormalComp4.z=0;
				NormalComp5.x=0;NormalComp5.y=0;NormalComp5.z=0;
			} else {
				NormalComp4=DrawMatrix[(Linhas*Quads*2)+((Colunas+1)*2)].FaceNormal;
				NormalComp5=DrawMatrix[((Linhas*Quads*2)+((Colunas+1)*2))+1].FaceNormal;
			}

			if ((((Linhas*Quads*2)+((Colunas)*2))<0) || (((Linhas*Quads*2)+((Colunas)*2))>NumTiles)) {
				NormalComp6.x=0;NormalComp6.y=0;NormalComp6.z=0;
		//		NormalComp8.x=0;NormalComp8.y=0;NormalComp8.z=0;
			} else {
				NormalComp6=DrawMatrix[(Linhas*Quads*2)+((Colunas)*2)].FaceNormal;
		//		NormalComp8=DrawMatrix[((Linhas*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			Normal=NormalComp1+NormalComp2+NormalComp3+NormalComp4+NormalComp5+NormalComp6;
			Normal.Normalize();
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+3]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+4]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+5]=Normal.z;
						
			
			if (((((Linhas)*Quads*2)+((Colunas)*2))<0) || ((((Linhas)*Quads*2)+((Colunas)*2))>NumTiles)) {
				NormalComp1.x=0;NormalComp1.y=0;NormalComp1.z=0;
				NormalComp2.x=0;NormalComp2.y=0;NormalComp2.z=0;
			} else {
				NormalComp1=DrawMatrix[((Linhas)*Quads*2)+((Colunas)*2)].FaceNormal;
				NormalComp2=DrawMatrix[(((Linhas)*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			if (((((Linhas)*Quads*2)+((Colunas+1)*2))<0) || ((((Linhas)*Quads*2)+((Colunas+1)*2))>NumTiles)) {
		//		NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
				NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
			} else {
		//		NormalComp3=DrawMatrix[((Linhas)*Quads*2)+((Colunas+1)*2)].FaceNormal;
				NormalComp3=DrawMatrix[(((Linhas)*Quads*2)+((Colunas+1)*2))+1].FaceNormal;
			}

			if (((((Linhas+1)*Quads*2)+((Colunas+1)*2))<0) || ((((Linhas+1)*Quads*2)+((Colunas+1)*2))>NumTiles)) {
				NormalComp4.x=0;NormalComp4.y=0;NormalComp4.z=0;
				NormalComp5.x=0;NormalComp5.y=0;NormalComp5.z=0;
			} else {
				NormalComp4=DrawMatrix[((Linhas+1)*Quads*2)+((Colunas+1)*2)].FaceNormal;
				NormalComp5=DrawMatrix[(((Linhas+1)*Quads*2)+((Colunas+1)*2))+1].FaceNormal;
			}

			if (((((Linhas+1)*Quads*2)+((Colunas)*2))<0) || ((((Linhas+1)*Quads*2)+((Colunas)*2))>NumTiles)) {
				NormalComp6.x=0;NormalComp6.y=0;NormalComp6.z=0;
		//		NormalComp8.x=0;NormalComp8.y=0;NormalComp8.z=0;
			} else {
				NormalComp6=DrawMatrix[((Linhas+1)*Quads*2)+((Colunas)*2)].FaceNormal;
		//		NormalComp8=DrawMatrix[(((Linhas+1)*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			Normal=NormalComp1+NormalComp2+NormalComp3+NormalComp4+NormalComp5+NormalComp6;
			Normal.Normalize();
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+6]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+7]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+8]=Normal.z;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+15]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+16]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+17]=Normal.z;

			if (((((Linhas)*Quads*2)+((Colunas-1)*2))<0) || ((((Linhas)*Quads*2)+((Colunas-1)*2))>NumTiles)) {
				NormalComp1.x=0;NormalComp1.y=0;NormalComp1.z=0;
				NormalComp2.x=0;NormalComp2.y=0;NormalComp2.z=0;
			} else {
				NormalComp1=DrawMatrix[((Linhas)*Quads*2)+((Colunas-1)*2)].FaceNormal;
				NormalComp2=DrawMatrix[(((Linhas)*Quads*2)+((Colunas-1)*2))+1].FaceNormal;
			}

			if (((((Linhas)*Quads*2)+((Colunas)*2))<0) || ((((Linhas)*Quads*2)+((Colunas)*2))>NumTiles)) {
		//		NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
				NormalComp3.x=0;NormalComp3.y=0;NormalComp3.z=0;
			} else {
		//		NormalComp3=DrawMatrix[((Linhas)*Quads*2)+((Colunas)*2)].FaceNormal;
				NormalComp3=DrawMatrix[(((Linhas)*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			if (((((Linhas+1)*Quads*2)+((Colunas)*2))<0) || ((((Linhas+1)*Quads*2)+((Colunas)*2))>NumTiles)) {
				NormalComp4.x=0;NormalComp4.y=0;NormalComp4.z=0;
				NormalComp5.x=0;NormalComp5.y=0;NormalComp5.z=0;
			} else {
				NormalComp4=DrawMatrix[((Linhas+1)*Quads*2)+((Colunas)*2)].FaceNormal;
				NormalComp5=DrawMatrix[(((Linhas+1)*Quads*2)+((Colunas)*2))+1].FaceNormal;
			}

			if (((((Linhas+1)*Quads*2)+((Colunas-1)*2))<0) || ((((Linhas+1)*Quads*2)+((Colunas-1)*2))>NumTiles)) {
				NormalComp6.x=0;NormalComp6.y=0;NormalComp6.z=0;
		//		NormalComp8.x=0;NormalComp8.y=0;NormalComp8.z=0;
			} else {
				NormalComp6=DrawMatrix[((Linhas+1)*Quads*2)+((Colunas-1)*2)].FaceNormal;
		//		NormalComp8=DrawMatrix[(((Linhas+1)*Quads*2)+((Colunas-1)*2))+1].FaceNormal;
			}

			Normal=NormalComp1+NormalComp2+NormalComp3+NormalComp4+NormalComp5+NormalComp6;
			Normal.Normalize();
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+12]=Normal.x;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+13]=Normal.y;
			NormalArray[((Linhas*Quads*18)+(Colunas*18))+14]=Normal.z;

			TexArray[((Linhas*Quads*12)+(Colunas*12))]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+1]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+2]=1.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+3]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+4]=1.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+5]=1.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+6]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+7]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+8]=0.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+9]=1.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+10]=1.0f;
			TexArray[((Linhas*Quads*12)+(Colunas*12))+11]=1.0f;
			
			DrawMatrix[(Linhas*Quads*2)+(Colunas*2)].Texture=0;
			DrawMatrix[((Linhas*Quads*2)+(Colunas*2))+1].Texture=0;

			Z+=QuadSize;
		}
	}
	glVertexPointer(3,GL_FLOAT,0,&VertexArray[0]);
	glNormalPointer(GL_FLOAT,0,&NormalArray[0]);
	glTexCoordPointer(2,GL_FLOAT,0,&TexArray[0]);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
}

void Terrain::BuildMe(void) {
	PreTerrain=glGenLists(1);
	glNewList(PreTerrain,GL_COMPILE);

	DrawTrees();

	glBindTexture(GL_TEXTURE_2D,texture[0]);

	glDrawArrays(GL_TRIANGLES,0,((Terreno.Quads*Terreno.Quads*18/3)-1));

	// SkyDome

	glBindTexture(GL_TEXTURE_2D,texture[2]);
	glPushMatrix();
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	glTranslatef(-0.5f,-0.5f,-6.0f);
	gluCylinder(SkyDome, 3.0f, 3.0f, 8.0f, 32,32);
	glPopMatrix();

	// Sphere
	glDisable(GL_LIGHTING);
	glEnable(GL_ALPHA_TEST);

	glBindTexture(GL_TEXTURE_2D, Smoke[1].texID);
	glPushMatrix();
	glTranslatef(smokepos.x, smokepos.y-0.03f, smokepos.z);
	glRotatef(180.0f,1.0f,0.0f,0.0f);

	gluSphere(Sphere, 0.045f, 32,32);
	glPopMatrix();
	glDisable(GL_ALPHA_TEST);
	glEnable(GL_LIGHTING);

	glEndList();

}

AUX_RGBImageRec  * Terrain::LoadBMP(char * FileName) {
	FILE * File=NULL;
	if (!FileName) {
		cerr<<"FileName does not exist";
		return NULL;
	}

	File=fopen(FileName,"r");
	if (File) {
		fclose(File);
		return auxDIBImageLoad(FileName);
	}
	cerr<<"Invalid File " << FileName << "\n";
	return NULL;
}

int Terrain::LoadGLTextures(void) {
	int Status=false;
	AUX_RGBImageRec * TextureImage[4];

	memset(TextureImage,0,sizeof(void*)*1);

	if (TextureImage[0]=LoadBMP("grass.bmp")) {
		Status=true;
		glGenTextures(4,&texture[0]);
		glBindTexture(GL_TEXTURE_2D,texture[0]);
		
		glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0]->sizeX,TextureImage[0]->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[0]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	}
	
	if (TextureImage[0]) {
		if (TextureImage[0]->data) {
			free(TextureImage[0]->data);
		}
		free(TextureImage[0]);
	}

	if (TextureImage[1]=LoadBMP("water.bmp")) {
		Status=true;
		glBindTexture(GL_TEXTURE_2D,texture[1]);
		
		glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[1]->sizeX,TextureImage[1]->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[1]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	}
	
	if (TextureImage[1]) {
		if (TextureImage[1]->data) {
			free(TextureImage[1]->data);
		}
		free(TextureImage[1]);
	}
	
	if (TextureImage[2]=LoadBMP("sky.bmp")) {
		Status=true;
		glBindTexture(GL_TEXTURE_2D,texture[2]);
		
		glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[2]->sizeX,TextureImage[2]->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[2]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	}
	
	if (TextureImage[2]) {
		if (TextureImage[2]->data) {
			free(TextureImage[2]->data);
		}
		free(TextureImage[2]);
	}

	if (TextureImage[3]=LoadBMP("oak.bmp")) {
		Status=true;
		glBindTexture(GL_TEXTURE_2D,texture[3]);
		
		glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[3]->sizeX,TextureImage[3]->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[3]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	}
	
	if (TextureImage[3]) {
		if (TextureImage[3]->data) {
			free(TextureImage[3]->data);
		}
		free(TextureImage[3]);
	}
	
	if (!LoadTGA(&Tree[0],"tree.tga")) {
		std::cout << "Error loading the tree tga.\n";
	}

	if (!LoadTGA(&Smoke[0],"smoke.tga")) {
		std::cout << "Error loading the tree tga.\n";
	}

	if (!LoadTGA(&Smoke[1], "fire.tga")) {
		std::cout << "Error loading the tree tga.\n";
	}

	//textree.LoadTexture("water.bmp");

	return Status;
}

bool Terrain::LoadTGA(TextureImage *treetex, char *filename) {    
   GLubyte		TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};
   GLubyte		TGAcompare[12];
   GLubyte		header[6];
   GLuint		bytesPerPixel;
   GLuint		imageSize;
   GLuint		temp;
   GLuint		type=GL_RGBA;		
   FILE *file = fopen(filename, "rb");
   if(	file==NULL ||
      fread(TGAcompare,1,sizeof(TGAcompare),file)!=sizeof(TGAcompare) ||
      memcmp(TGAheader,TGAcompare,sizeof(TGAheader))!=0		||
      fread(header,1,sizeof(header),file)!=sizeof(header))
   {
      if (file == NULL)
         return false;
      else {
         fclose(file);
         return false;
      }
   }
   treetex->width  = header[1] * 256 + header[0];
   treetex->height = header[3] * 256 + header[2];
   if(	treetex->width	<=0	||
   treetex->height	<=0	||
   (header[4]!=24 && header[4]!=32))
   {
      fclose(file);
      return false;
   }
   treetex->bpp	= header[4];
   bytesPerPixel	= treetex->bpp/8;
   imageSize	= treetex->width*treetex->height*bytesPerPixel;
   treetex->imageData=(GLubyte *)malloc(imageSize);
   if(	treetex->imageData==NULL ||
   fread(treetex->imageData, 1, imageSize, file)!=imageSize)
   {
      if(treetex->imageData!=NULL)
         free(treetex->imageData);
      fclose(file);
      return false;
   }
   for(GLuint i=0; i<int(imageSize); i+=bytesPerPixel) {
      temp=treetex->imageData[i];
      treetex->imageData[i] = treetex->imageData[i + 2];
      treetex->imageData[i + 2] = temp;
   }

   fclose (file);		

   glGenTextures(1, &treetex[0].texID);
   glBindTexture(GL_TEXTURE_2D, treetex[0].texID);
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   if (treetex[0].bpp==24)
   {
      type=GL_RGB;
   } 
   glTexImage2D(GL_TEXTURE_2D, 0, type, treetex[0].width, treetex[0].height, 0, type, GL_UNSIGNED_BYTE, treetex[0].imageData);
   return true;
}

GLvoid glPrint(const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

    for (int loop=0; loop<=(strlen(text)-1);loop++)
       glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, text[loop]);
}
