#ifndef TERRAIN_H
#define TERRAIN_H
#include "mathclass.h"
#include <assert.h>
#include "texture.h"
//#include "minifmod.h"

typedef	struct	{
   GLubyte	*imageData;
   GLuint	bpp;
   GLuint	width;
   GLuint	height;
   GLuint	texID;
} TextureImage;

class MapTile {
public:
	Vector Vertex1,Vertex2,Vertex3;
	Vector Normal1,Normal2,Normal3,FaceNormal;
	int Texture;
};

class Terrain {
private:
	GLUquadricObj* SkyDome;
	GLUquadricObj* Sphere;
public:
	int Dimension;
	int Ratio;
	int BigDimension;
	int QuadSize;
	int Quads;
	int NumTiles;
	float increment;
	float acumulator;
	GLuint texture[5];
	TextureImage Tree[1];
	TextureImage Smoke[2];
	CTexture textree;
	
	GLfloat * VertexArray;
	GLfloat * TexArray;
	GLfloat * NormalArray;
	MapTile * DrawMatrix;
	BYTE * HeightMatrix;

public:
	Terrain(void);
	Terrain(char * FileName,int Size,int QSize);
	~Terrain(void);
	float GetHeight(int x,int y);
	void Initialize(void);
	void BuildMe(void);
	void DrawTree(int Quad);
	void DrawTrees(void);
	AUX_RGBImageRec * LoadBMP(char * FileName);
	int LoadGLTextures(void);
	bool LoadTGA(TextureImage *treetex, char *filename);
	void CreateWaterPlane();
};
#endif


