// Texture.cpp: implementation of the CTexture class.
//
//////////////////////////////////////////////////////////////////////

#include "Texture.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTexture::CTexture()
{
	texturebound=false;
}

CTexture::~CTexture()
{
	if (texturebound) glDeleteTextures(1,&texture[0]);
}

AUX_RGBImageRec  * CTexture::LoadBMP(char * FileName) {
	FILE * File=NULL;
	if (!FileName) {
		std::cerr<<"FileName does not exist";
		return NULL;
	}

	File=fopen(FileName,"r");
	if (File) {
		fclose(File);
		return auxDIBImageLoad(FileName);
	}
	std::cerr<<"Invalid File";
	return NULL;
}

bool CTexture::LoadTexture(char* name) {
	bool Status=false;
	AUX_RGBImageRec * TextureImage[1]; //

	memset(TextureImage,0,sizeof(void*)*1);

	if (TextureImage[0]=LoadBMP(name)) {
		Status=true;
		glGenTextures(1,&texture[0]);//
		texturebound=true;
		glBindTexture(GL_TEXTURE_2D,texture[0]);
		
		glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0]->sizeX,TextureImage[0]->sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[0]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	}
	
	if (TextureImage[0]) {
		if (TextureImage[0]->data) {
			free(TextureImage[0]->data);
		}
		free(TextureImage[0]);
	}

	return Status;
}

void CTexture::BindTexture(void) {
	glBindTexture(GL_TEXTURE_2D, texture[0]);
}